package cc.toph.simplycompat;

import cc.toph.simplycompat.registry.ItemsRegistry;
import dev.architectury.platform.Platform;
import dev.architectury.registry.CreativeTabRegistry;
import dev.architectury.registry.registries.DeferredRegister;
import dev.architectury.registry.registries.RegistrySupplier;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.text.Text;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class SimplyCompat {

  public static final String MOD_ID = "simplycompat";

  public static final DeferredRegister<ItemGroup> TABS = DeferredRegister.create(
    SimplyCompat.MOD_ID,
    RegistryKeys.ITEM_GROUP
  );

  public static final RegistrySupplier<ItemGroup> SIMPLYCOMPAT = TABS.register(
    "simplycompat", // Tab ID
    () ->
      CreativeTabRegistry.create(
        Text.translatable("itemGroup.simplycompat.simplycompat"), // Tab Name
        () -> new ItemStack(Items.AMETHYST_SHARD) // TODO: Icon
      )
  );

  public static final Logger LOGGER = LogManager.getLogger(MOD_ID);

  public static boolean isConfigOutdated;

  //  public static GeneralConfig generalConfig;
  //  public static LootConfig lootConfig;
  //  public static GemEffectsConfig gemEffectsConfig;
  //  public static RunicEffectsConfig runicEffectsConfig;
  //  public static StatusEffectsConfig statusEffectsConfig;
  //  public static UniqueEffectsConfig uniqueEffectsConfig;
  //  public static WeaponAttributesConfig weaponAttributesConfig;
  //
  //  public static String minimumEldritchEndVersion = "0.2.40";
  //  public static String minimumSpellPowerVersion = "0.10.0+1.20.1";

  public static void init() {
    //CONFIG

    //    SimplyCompatConfig.init();
    //
    //    AutoConfig.register(ConfigWrapper.class, PartitioningSerializer.wrap(JanksonConfigSerializer::new));
    //    generalConfig = AutoConfig.getConfigHolder(ConfigWrapper.class).getConfig().general;
    ////        lootConfig = AutoConfig.getConfigHolder(ConfigWrapper.class).getConfig().loot;
    ////        gemEffectsConfig = AutoConfig.getConfigHolder(ConfigWrapper.class).getConfig().gem_effects;
    ////        runicEffectsConfig = AutoConfig.getConfigHolder(ConfigWrapper.class).getConfig().runic_effects;
    ////        statusEffectsConfig = AutoConfig.getConfigHolder(ConfigWrapper.class).getConfig().status_effects;
    ////        uniqueEffectsConfig = AutoConfig.getConfigHolder(ConfigWrapper.class).getConfig().unique_effects;
    //    weaponAttributesConfig = AutoConfig.getConfigHolder(ConfigWrapper.class).getConfig().weapon_attributes;

    String version = SimplyCompatExpectPlatform.getVersion();
    String defaultConfig = String.format(
      """
      {
        "regen_simplycompat_config_file": false,
        "config_version": %s
      }""",
      version.substring(0, 4)
    );

    //    File configFile = Config.createFile("config/simplycompat_extra/backupconfig.json", defaultConfig, false);
    //    JsonObject json = Config.getJsonObject(Config.readFile(configFile));
    //    isConfigOutdated = !json.has("config_version") || !version.startsWith(json.get("config_version").getAsString());
    //
    //    SimplySwordsConfig.generateConfigs(json == null || !json.has("regen_simplyswords_config_file") || json.get("regen_simplyswords_config_file").getAsBoolean());
    //    SimplySwordsConfig.loadConfig();

    SimplyCompat.TABS.register();
    ItemsRegistry.ITEMS.register();
    //    SoundRegistry.SOUND.register();
    //    EffectRegistry.EFFECT.register();
    //    EntityRegistry.ENTITIES.register();
    //    ModLootTableModifiers.init();
    //    if (passVersionCheck("eldritch_end", minimumEldritchEndVersion)) {
    //      EldritchEndCompat.registerModItems();
    //      EldritchEndCompatRegistry.EFFECT.register();
    //    }

    //    try {
    //      FileCopier.copyFileToConfigDirectory();
    //    } catch (IOException e) {
    //      throw new RuntimeException(e);
    //    }

    //Don't announce via in-game chat because that's kinda annoying
    //ClientPlayerEvent.CLIENT_PLAYER_JOIN.register(new EventGameStart());

    System.out.println(
      SimplyCompatExpectPlatform.getConfigDirectory().toAbsolutePath().normalize().toString()
    );
  }

  public static boolean passVersionCheck(String modId, String requiredVersion) {
    if (Platform.isModLoaded(modId)) {
      return Platform.getMod(modId).getVersion().compareTo(requiredVersion) >= 0;
    }
    return false;
  }
}
